from ..magic_sets_processing import _wlq_dependencies
import pytest
import numpy as np


@pytest.fixture
def dep_mat():
    dep_mat = np.array(
        [
            [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0],
            [0, 0, 0, 0, 0, 0, 1, 1, 0, 0, 0],
            [0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0],
            [0, 0, 0, 0, 1, 0, 0, 0, 1, 0, 0],
            [0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0],
            [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0],
            [1, 0, 0, 1, 0, 0, 0, 0, 0, 1, 0],
            [0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 1],
            [1, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1],
            [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0],
            [0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0],
        ]
    )
    return dep_mat


def test_wlq_dependencies(dep_mat):
    wlq_symb_idxs = {6, 7}
    deps = _wlq_dependencies(7, dep_mat, wlq_symb_idxs)
    assert deps == {6}
    deps = _wlq_dependencies(6, dep_mat, wlq_symb_idxs)
    assert deps == {6}
